/*-----------------------------------------------------------------------------
	Global inlines used for XC_Engine
-----------------------------------------------------------------------------*/

#ifndef KILL_ENGINE
inline ULevel* GetActiveLevel( UXC_GameEngine* Other)
{
	if ( XCGE_Defaults->b451Setup )	return Other->GEntry;
	return Other->GLevel;
}

inline ULevel* GetEntryLevel( UXC_GameEngine* Other)
{
	if ( XCGE_Defaults->b451Setup )	return Other->GEntry + 1;
	return Other->GEntry;
}
#else
inline ULevel* GetActiveLevel( UGameEngine* Other)
{
	return Other->GLevel;
}

inline ULevel* GetEntryLevel( UGameEngine* Other)
{
	return Other->GEntry;
}
#endif
/*
inline ULevelBase* GetPendingLevel( UXC_GameEngine* Other)
{
	if ( b451Setup )	return  Other->GEntry + 2;
	return  Other->GEntry + 1;
}
*/
inline UBOOL StaticMover( AActor* Other)
{
	return Other && Other->bIsMover && Other->Brush && (Other->bNoDelete || Other->bStatic);
}

inline AActor* FindNamedActor( ULevel* Level, const TCHAR* ActorName)
{
	if ( Level )
	{	INT i=0;
		while ( i<Level->Actors.Num() )
		{
			if ( Level->Actors(i) && !Level->Actors(i)->bDeleteMe && (appStricmp(Level->Actors(i)->GetName(), ActorName) == 0) )
				return Level->Actors(i);
			i++;
		}
	}
	return NULL;
}

inline UObject* FindNamedObject( const TCHAR* ObjectName)
{
	for ( TObjectIterator<UObject> It; It; ++It )
		if ( appStricmp( It->GetName(), ObjectName) == 0 || appStricmp( It->GetFullName(), ObjectName) == 0 )
			return *It;
	return NULL;
}

inline FString StripPath( const FString* Dir)
{
	INT PathSeparator = Max( Dir->InStr(TEXT("/"),1), Dir->InStr( FString::Chr(92),1)) + 1;
	if ( PathSeparator > 0 )
		return Dir->Mid( PathSeparator);
	return *Dir;
}

inline FString ByDelimiter( FString Str, const FString* Delimiter, INT Skip=0)
{
	while ( 1 )
	{
		INT i = Str.InStr( *Delimiter);
		if ( i < 0 )
		{
			if ( !Skip )
				return Str;
			return FString( TEXT("") );
		}
		else
		{
			if ( !Skip )
				return Str.Left( i);
			Str = Str.Mid( i + Delimiter->Len() );
			Skip--;
		}
	}
	return FString( TEXT("") );
}

inline FString ByDelimiter( FString Str, const TCHAR* Delimiter, INT Skip=0)
{
	while ( 1 )
	{
		INT i = Str.InStr( Delimiter);
		if ( i < 0 )
		{
			if ( !Skip )
				return Str;
			return FString( TEXT("") );
		}
		else
		{
			if ( !Skip )
				return Str.Left( i);
			Str = Str.Mid( i + appStrlen(Delimiter) );
			Skip--;
		}
	}
	return FString( TEXT("") );
}

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
